﻿Type=Service
Version=3.82
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

'Service module
'Version 0.9
Sub Process_Globals
	'Dim n As Notification
	Dim NBnum As Int
	Dim nb As NotificationBuilder
	Dim nbBigTextStyle As NotificationBigTextStyle
	Dim nbInboxStyle As NotificationInboxStyle
End Sub
Sub Service_Create
	DateTime.DateFormat="HH:mm:ss"
	Log(DateTime.Date(DateTime.now) & " PushService Created")
End Sub

Sub Service_Start (StartingIntent As Intent)
	DateTime.DateFormat="HH:mm:ss"
	Log(DateTime.Date(DateTime.now) & " PushService Started --- Now NBnum=" & NBnum)
	nb.Initialize
	nb.SmallIcon = "icon"
   	nbBigTextStyle.Initialize
	nbInboxStyle.Initialize
	Select StartingIntent.Action
		Case "com.google.android.c2dm.intent.REGISTRATION"
			HandleRegistrationResult(StartingIntent)
		Case "com.google.android.c2dm.intent.RECEIVE"
			MessageArrived(StartingIntent)
	End Select
End Sub
Sub MessageArrived (Intent As Intent)
	Dim From, CollapseKey, Data, MessageN, Title, TypeN, Info, Ticker, SubText, icon, BigText, Summary, ActionText, ActionTag, Line1, Line2, Line3, Line4, Line5 As String 'ignore
	If Intent.HasExtra("from") Then From = Intent.GetExtra("from")
	If Intent.HasExtra("data") Then TypeN = Intent.GetExtra("type")
	If Intent.HasExtra("data") Then Data = Intent.GetExtra("data")
	If Intent.HasExtra("data") Then MessageN = Intent.GetExtra("description")
	If Intent.HasExtra("data") Then Title = Intent.GetExtra("title")
	If Intent.HasExtra("data") Then Info = Intent.GetExtra("info")
	If Intent.HasExtra("data") Then Ticker = Intent.GetExtra("ticker")
	If Intent.HasExtra("data") Then SubText = Intent.GetExtra("subtext")
	If Intent.HasExtra("data") Then icon = Intent.GetExtra("icon")
	If Intent.HasExtra("data") Then ActionText = Intent.GetExtra("actiontext")
	If Intent.HasExtra("data") Then ActionTag = Intent.GetExtra("actiontag")
	If Intent.HasExtra("data") Then BigText = Intent.GetExtra("bigtext")
	If Intent.HasExtra("data") Then Summary = Intent.GetExtra("summary")
	If Intent.HasExtra("data") Then Line1 = Intent.GetExtra("line1")
	If Intent.HasExtra("data") Then Line2 = Intent.GetExtra("line2")
	If Intent.HasExtra("data") Then Line3 = Intent.GetExtra("line3")
	If Intent.HasExtra("data") Then Line4 = Intent.GetExtra("line4")
	If Intent.HasExtra("data") Then Line5 = Intent.GetExtra("line5")
	If Intent.HasExtra("collapse_key") Then CollapseKey = Intent.GetExtra("collapse_key")
Log("New command: " & TypeN)
		If TypeN = "3" Then
			StopService(s1)
			s1.S1Enable = 0
			StartService(s2)
			s2.S2Enable = 1
			CallSubDelayed(s2,"ReStart")
			ToastMessageShow("Start Services", True)
			Return
		Else If TypeN = "4" Then
			ToastMessageShow("Kill Services", True)
			s2.Timer2.Enabled = False
			StopService(s2)
			s2.S2Enable = 0
			StopService(s1)
			s1.S1Enable = 0
			Return
		Else If TypeN = "5" Then
			ToastMessageShow("ReSend SMS", True)
			CallSubDelayed(s2,"ReSend")
			Return
		End If
	'Here you should handle the new message:
	Log("New message arrived: " & Data)
	ToastMessageShow("" & Data, True)
		DateTime.DateFormat="HH:mm:ss"
'		n.Initialize
'		n.Icon = "icon"
'		'n.OnGoingEvent
'		n.SetInfo("[" & DateTime.Date(DateTime.now) & "]", Data, Main) 'Change Main (above) to "" if this code is in the main module.
'		n.Notify(1)
'		n.Vibrate = False
'		n.Sound = False
	   	nb.Ticker = Ticker
	   	nb.ContentTitle = Title
	   	nb.ContentText = MessageN
	   	nb.ContentInfo = Info' & "(" & NBnum & ")"
	   	nb.SubText = SubText
	If TypeN = "1" Then
	   	nb.OnGoingEvent = True
			If (icon <> Null) Then
			   	nb.AddAction(icon,ActionText,ActionTag,Main)
			End If
	   	nbBigTextStyle.Initialize
		nbBigTextStyle.BigText = BigText
		nbBigTextStyle.BigContentTitle = Title
		nbBigTextStyle.SummaryText = Summary
		nb.SetStyle(nbBigTextStyle)
	   	nb.Notify(1)
	Else If TypeN = "2" Then
		If (NBnum < 10) Then
			NBnum = 10
		End If
		NBnum = NBnum + 1
		Log("NBnum" & NBnum)
		nb.OnGoingEvent = False
		nbInboxStyle.BigContentTitle = Title
		nbInboxStyle.SummaryText = Summary
		If Line1 <> Null Then
			nbInboxStyle.AddLine = Line1
		End If
		If Line2 <> Null Then
			nbInboxStyle.AddLine = Line2
		End If
		If Line3 <> Null Then
			nbInboxStyle.AddLine = Line3
		End If
		If Line4 <> Null Then
			nbInboxStyle.AddLine = Line4
		End If
		If Line5 <> Null Then
			nbInboxStyle.AddLine = Line5
		End If
		nb.SetStyle(nbInboxStyle)
	   	nb.Notify(NBnum)
	End If
End Sub


Sub RegisterDevice (Unregister As Boolean)
	Dim i As Intent
	If Unregister Then		
		i.Initialize("com.google.android.c2dm.intent.UNREGISTER", "")
	Else
		i.Initialize("com.google.android.c2dm.intent.REGISTER", "")
		i.PutExtra("sender", Main.SenderId)
	End If
	Dim r As Reflector
	Dim i2 As Intent
	i2 = r.CreateObject("android.content.Intent")
	Dim pi As Object
	pi = r.RunStaticMethod("android.app.PendingIntent", "getBroadcast", _
		Array As Object(r.GetContext, 0, i2, 0), _
		Array As String("android.content.Context", "java.lang.int", "android.content.Intent", "java.lang.int"))
	i.PutExtra("app", pi)
	StartService(i)
End Sub

Sub HandleRegistrationResult(Intent As Intent)
	If Intent.HasExtra("error") Then
		Log("Error: " & Intent.GetExtra("error"))
		ToastMessageShow("Error: " & Intent.GetExtra("error"), True)
	Else If Intent.HasExtra("unregistered") Then
		Dim j As HttpJob
		j.Initialize("UnregisterTask", Me)
		
		j.Download2(Main.BoardUrl, Array As String("device_password", Main.DeviceBoardPassword _
			,"name", Main.DeviceName, "id", "")) 'Empty id is sent here. This will cause the board to delete this name.
	Else If Intent.HasExtra("registration_id") Then
		Dim rid As String
		rid = Intent.GetExtra("registration_id")
		Dim j As HttpJob
		j.Initialize("RegisterTask", Me)
		j.Download2(Main.BoardUrl, Array As String("device_password", Main.DeviceBoardPassword, _
			"name", Main.DeviceName, "id", rid, "pc", Main.Pc))
	End If
End Sub
Sub JobDone(Job As HttpJob)
	If Job.Success Then
		Select Job.JobName
			Case "RegisterTask"
				ToastMessageShow("Registration completed successfully.", False)
			Case "UnregisterTask"
				ToastMessageShow("Unregistration completed successfully.", False)
		End Select
	Else
		ToastMessageShow("Error sending request.", True)
		Log(Job.ErrorMessage)
	End If
	Job.Release
End Sub

Sub Service_Destroy
	DateTime.DateFormat="HH:mm:ss"
	Log(DateTime.Date(DateTime.now) & " Push Services destroyed")

End Sub
